【Codeforces】Codeforces Round #427 (Div. 2) D. Palindromic characteristics DP回文串

来源:互联网 发布:qt5串口编程详解 编辑:程序博客网 时间:2024/05/22 05:42
D. Palindromic characteristics
time limit per test
3 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Palindromic characteristics of string s with length |s| is a sequence of |s| integers, where k-th number is the total number of non-empty substrings of s which are k-palindromes.

A string is 1-palindrome if and only if it reads the same backward as forward.

A string is k-palindrome (k > 1) if and only if:

  1. Its left half equals to its right half.
  2. Its left and right halfs are non-empty (k - 1)-palindromes.

The left half of string t is its prefix of length ⌊|t| / 2⌋, and right half — the suffix of the same length. ⌊|t| / 2⌋ denotes the length of string tdivided by 2, rounded down.

Note that each substring is counted as many times as it appears in the string. For example, in the string "aaa" the substring "a" appears 3 times.

Input

The first line contains the string s (1 ≤ |s| ≤ 5000) consisting of lowercase English letters.

Output

Print |s| integers — palindromic characteristics of string s.

Examples
input
abba
output
6 1 0 0 
input
abacaba
output
12 4 1 0 0 0 0 
Note

In the first example 1-palindromes are substring «a», «b», «b», «a», «bb», «abba», the substring «bb» is 2-palindrome. There are no 3- and 4-palindromes here.


题目链接:http://codeforces.com/contest/835/problem/D

题意: 给以个字符串s,  |s| <= 5000 定义k回文: 这条串左右两边相同并且左边右边是k-1回文串, 让你输出所有k回文的个数。

解题思路: 一个串是k回文, 要求两边相同并且都是k-1回文,  我们可以用n^2处理处所有区间的回文串, dp[i][j] 表示区间ij 最大是几回文串,  要保证k回文, 首先本身是回文, 其次从左右两边取一个max + 1就好。

如果一个串是k回文, 那么他一定是k-1 回文, 所以最后求和的时候倒序加一下。   我先处理出所有的1回文,   再去dp转移。 

满足条件的话, 转移方程为 dp[i][j] = max(dp[i][j], dp[i][mid] + 1);

//2017-08-02 11:15//2017-08-02 12:30#include<cstdio>#include<cstring>#include<cmath>#include<cstdlib>#include<algorithm>using namespace std;typedef long long LL;const int MaxN = 5e3;int dp[MaxN + 5][MaxN + 5];LL ans[MaxN + 5];char s[MaxN + 5];int len;void init(){for(int i = 0; i < len; i++){int l = 0;while(i - l >= 0 && i + l < len && (s[i - l] == s[i + l]))dp[i - l][i + l] = 1, l++, ans[1]++;l = 0;while(i - l >= 0 && i + l + 1 < len &&(s[i - l] == s[i + l + 1]))dp[i - l][i + l + 1] = 1, l++, ans[1]++;}}void solve(){for(int k = 2; k <= len; k++){for(int i = 0; i < len; i++){int j = i + k - 1;if(j > len) break;int mid = i + k / 2 - 1;if(dp[i][j] && dp[i][mid]){dp[i][j] = max(dp[i][j], dp[i][mid] + 1);ans[dp[i][j]]++;}}}}int main(){while(~scanf("%s", s)){len = strlen(s);init();solve();for(int i = len; i >= 2; i--) ans[i] = ans[i] + ans[i + 1];for(int i = 1; i <= len; i++) printf("%d ", ans[i]);}return 0;}




阅读全文
0 0